package ij2x.util;

import ij.Prefs;

import java.awt.Color;
import java.awt.Component;
import java.awt.Graphics;
import java.awt.Graphics2D;
import java.awt.GraphicsConfiguration;
import java.awt.GraphicsDevice;
import java.awt.GraphicsEnvironment;
import java.awt.Image;
import java.awt.RenderingHints;
import java.awt.Toolkit;
import java.awt.Transparency;
import java.awt.geom.RoundRectangle2D;
import java.awt.image.BufferedImage;
import java.awt.image.ColorModel;
import java.awt.image.PixelGrabber;
import java.net.URL;

import javax.swing.Icon;
import javax.swing.ImageIcon;
import javax.swing.UIDefaults;
import javax.swing.UIManager;

/**
 * <p>Title: </p>
 *
 * <p>Description: </p>
 *
 * <p>Copyright: Copyright (c) 2012</p>
 *
 * <p>Company: </p>
 *
 * @author not attributable
 * @version 1.0
 */
public class AWTImages {

    //private static String fileType = ".gif";
    private static String[] fileType = {".gif",".png"};
    private static String dir;


    public static Icon createIcon(Component panel, String key){
        Icon icon = null;
        String fileName=key + getFileType();
        if(getImageDir() == null){
           dir="images/";
        }
        String path = getImageDir()+fileName;
        //System.out.println("dir="+getImageDir());
        //System.out.println("fileName="+fileName);
       try {
           URL url = panel.getClass().getResource(path);
           Image image = Toolkit.getDefaultToolkit().createImage(url);
           if (url != null) {
               icon = new ImageIcon(image);
             }
           } catch (Exception ex) {
         }
           return icon;
    }

    public static Icon createIcon(Object panel, String key){
        Icon icon = null;
        String fileName=key + getFileType();
        if(getImageDir() == null){
           dir="images/";
        }
        String path = getImageDir()+fileName;
       try {
           URL url = panel.getClass().getResource(path);
           Image image = Toolkit.getDefaultToolkit().createImage(url);
           if (url != null) {
               icon = new ImageIcon(image);
             }
           } catch (Exception ex) {
         }
           return icon;
    }

    public static Icon createIcon(Component panel, String key, int type){
        Icon icon = null;
        String fileName=key + getFileType(type);
        if(getImageDir() == null){
           dir="images/";
        }
        String path = getImageDir()+fileName;
       try {
           URL url = panel.getClass().getResource(path);
           Image image = Toolkit.getDefaultToolkit().createImage(url);
           if (url != null) {
               icon = new ImageIcon(image);
             }
           } catch (Exception ex) {
         }
           return icon;
    }

    public static Icon createIcon(Object panel, String key, int type){
        Icon icon = null;
        String fileName=key + getFileType(type);
        if(getImageDir() == null){
           dir="images/";
        }
        String path = getImageDir()+fileName;
       try {
           URL url = panel.getClass().getResource(path);
           Image image = Toolkit.getDefaultToolkit().createImage(url);
           if (url != null) {
               icon = new ImageIcon(image);
             }
           } catch (Exception ex) {
         }
           return icon;
    }

    public static Icon createBufferedIcon(Component panel, String key, Image bgImage, int SIZE){
        Icon icon = null;
        String fileName=key + getFileType();
        if(getImageDir() == null){
           dir="images/";
        }
        String path = getImageDir()+fileName;
        //System.out.println("path="+path);
       try {
           URL url = panel.getClass().getResource(path);
           Image image = Toolkit.getDefaultToolkit().createImage(url);
           if (url != null && bgImage != null) {
               BufferedImage bimage = toBufferedImage(image, bgImage, SIZE, SIZE);
               icon = new ImageIcon(bimage);
             }
           } catch (Exception ex) {
         }
           return icon;
    }
    public static Icon createBufferedIcon(Component panel, String key, int SIZE, int type){
        Icon icon = null;
        String fileName=key + getFileType(type);
        if(getImageDir() == null){
           dir="images/";
        }
        String path = getImageDir()+fileName;
        //System.out.println("path="+path);
       try {
           URL url = panel.getClass().getResource(path);
           //System.out.println("URL="+url.toString());
           Image image = Toolkit.getDefaultToolkit().createImage(url);
           if (url != null) {
               BufferedImage bimage = toBufferedImage(image, SIZE);
               icon = new ImageIcon(bimage);
             }
           } catch (Exception ex) {
         }
           return icon;
    }
    public static Icon createBufferedIcon(Component panel, String key, Image bgImage, int SIZE, int type){
        Icon icon = null;
        String fileName=key + getFileType(type);
        if(getImageDir() == null){
           dir="images/";
        }
        String path = getImageDir()+fileName;
       try {
           URL url = panel.getClass().getResource(path);
           Image image = Toolkit.getDefaultToolkit().createImage(url);
           if (url != null && bgImage != null) {
               BufferedImage bimage = toBufferedImage(image, bgImage, SIZE, SIZE);
               icon = new ImageIcon(bimage);
             }
           } catch (Exception ex) {
         }
           return icon;
    }
    public static Icon createBufferedIcon(Component panel, String key, Image bgImage, int XSIZE, int YSIZE, int type){
        Icon icon = null;
        String fileName=key + getFileType(type);
        if(getImageDir() == null){
           dir="images/";
        }
        String path = getImageDir()+fileName;
       try {
           URL url = panel.getClass().getResource(path);
           Image image = Toolkit.getDefaultToolkit().createImage(url);
           if (url != null && bgImage != null) {
               BufferedImage bimage = toBufferedImage(image, bgImage, XSIZE, YSIZE);
               icon = new ImageIcon(bimage);
             }
           } catch (Exception ex) {
         }
           return icon;
    }
    public static Icon createBufferedIcon(Component panel, String key, Image bgImage, Image imageIcon){
        Icon icon = null;
        String fileName=key + getFileType();
        if(getImageDir() == null){
           dir="images/";
        }
        String path = getImageDir()+fileName;
       try {
           URL url = panel.getClass().getResource(path);
           Image image = Toolkit.getDefaultToolkit().createImage(url);
           if (url != null && bgImage != null) {
               BufferedImage bimage = toBufferedImage(image, bgImage, imageIcon);
               icon = new ImageIcon(bimage);
             }
           } catch (Exception ex) {
         }
           return icon;
    }

    public static String getFileType(){
           return fileType[0];
    }
    private static String getFileType(int i){
           return fileType[i];
    }
    public static String getImageDir(){
           return dir;
    }
    public static void setImageDir(String directory){
        dir=Prefs.getString(directory);
        //System.out.println(dir);
    }

    /**
     * Splits an image into count subimages.
     */
    public static BufferedImage[] split(Image image, int count, boolean isHorizontal) {
        BufferedImage src = toBufferedImage(image);
        if (count == 1) {
            return new BufferedImage[]{src};
        }

        BufferedImage[] parts = new BufferedImage[count];
        for (int i = 0; i < count; i++) {
            if (isHorizontal) {
                parts[i] = src.getSubimage(
                        src.getWidth() / count * i, 0,
                        src.getWidth() / count, src.getHeight());
            } else {
                parts[i] = src.getSubimage(
                        0, src.getHeight() / count * i,
                        src.getWidth(), src.getHeight() / count);
            }
        }
        return parts;
    }

    /**
     * Splits an image into count subimages.
     */
    public static BufferedImage[][] splitAll(Image image, int arraycount, int count, boolean isHorizontal) {
        BufferedImage src = toBufferedImage(image);
        BufferedImage[] ssrc = split(src, 20, true);
        BufferedImage[][] parts = new BufferedImage[arraycount][count];
        for (int i = 0; i < arraycount; i++) {
            for (int j = 0; j < count; j++) {
                if (isHorizontal) {
                    //System.out.println("["+i+"]"+"["+j+"]");
                    parts[i][j] = ssrc[i].getSubimage(
                            ssrc[i].getWidth() / count * j, 0,
                            ssrc[i].getWidth() / count, src.getHeight());
                } else {
                    parts[i][j] = ssrc[i].getSubimage(
                            0, ssrc[i].getHeight() / count * j,
                            src.getWidth(), ssrc[i].getHeight() / count);
                }
            }

        }return parts;
    }
    public static BufferedImage toBufferedImage(Image image) {
        if (image instanceof BufferedImage) {
            return (BufferedImage) image;
        }

        // Create a buffered image with a format that's compatible with the screen
        BufferedImage bimage = null;

            // Determine if the image has transparent pixels; for this method's
            // implementation, see e661 Determining If an Image Has Transparent Pixels
            boolean hasAlpha=false;
            try {
                //hasAlpha = hasAlpha(image);
                hasAlpha = true;
           } catch (IllegalAccessError e) {
                // If we can't determine this, we assume that we have an alpha,
                // in order not to loose data.
            }

            if (bimage == null) {
                // Create a buffered image using the default color model
                int type = BufferedImage.TYPE_INT_RGB;
                if (hasAlpha) {
                    type = BufferedImage.TYPE_INT_ARGB;
                }
                bimage = new BufferedImage(image.getWidth(null), image.getHeight(null), type);
            }

        // Copy image to buffered image
        Graphics g = bimage.createGraphics();

        // Paint the image onto the buffered image
        g.drawImage(image, 0, 0, null);
        g.dispose();

        return bimage;
    }
    public static BufferedImage toBufferedImage(Image image, Image icon, int XSIZE, int YSIZE) {
        if (image instanceof BufferedImage) {
            return (BufferedImage) image;
        }
        int width = XSIZE;
        int height = YSIZE;
        // This code ensures that all the pixels in the image are loaded
        image = new ImageIcon(image).getImage();
        icon = new ImageIcon(icon).getImage();

        // Create a buffered image with a format that's compatible with the screen
        BufferedImage bimage = null;
            // Determine if the image has transparent pixels; for this method's
            // implementation, see e661 Determining If an Image Has Transparent Pixels
            boolean hasAlpha;
            try {
                hasAlpha = hasAlpha(image);
            } catch (IllegalAccessError e) {
                // If we can't determine this, we assume that we have an alpha,
                // in order not to loose data.
                hasAlpha = true;
            }

            GraphicsEnvironment ge = GraphicsEnvironment.getLocalGraphicsEnvironment();
            try {
                // Determine the type of transparency of the new buffered image
                int transparency = Transparency.OPAQUE;
                if (hasAlpha) {
                    transparency = Transparency.TRANSLUCENT;
                }

                // Create the buffered image
                GraphicsDevice gs = ge.getDefaultScreenDevice();
                GraphicsConfiguration gc = gs.getDefaultConfiguration();
                bimage = gc.createCompatibleImage(
                		width, height, transparency);
            } catch (Exception e) {
                //} catch (HeadlessException e) {
                // The system does not have a screen
            }

            if (bimage == null) {
                // Create a buffered image using the default color model
                int type = BufferedImage.TYPE_INT_RGB;
                if (hasAlpha) {
                    type = BufferedImage.TYPE_INT_ARGB;
                }
                bimage = new BufferedImage(width, height, type);
            }

            // Copy image to buffered image
            Graphics2D g2d = bimage.createGraphics();
            UIDefaults uid = UIManager.getLookAndFeel().getDefaults();
            Color osColor = uid.getColor("Panel.background");
            g2d.setRenderingHint(RenderingHints.KEY_ANTIALIASING, RenderingHints.VALUE_ANTIALIAS_ON);
            
            int xloci = (width-icon.getWidth(null))/2;
            int xloc = (width-image.getWidth(null))/2;
            int yloci = (height-icon.getHeight(null))/2;
            int yloc = (height-image.getHeight(null))/2;

            // Paint the background image onto the buffered image
            g2d.drawImage(icon, xloci, yloci, null);

            // Paint the border onto the buffered image
            g2d.setColor(osColor.darker());
            RoundRectangle2D.Double rrect2D = new RoundRectangle2D.Double(0.0, 0.0, (double)width-1.0, (double)height-1.0, 6.0, 6.0);
            g2d.draw(rrect2D);
            g2d.setColor(osColor.brighter());
            rrect2D = new RoundRectangle2D.Double(1.0, 1.0, (double)width-3.0, (double)height-3.0, 6.0, 6.0);
            g2d.draw(rrect2D);

            // Paint the image icons onto the buffered image
            g2d.drawImage(image, xloc, yloc, null);
            g2d.dispose();

            return bimage;
    }
    public static BufferedImage toBufferedImage(Image image, int SIZE) {
        if (image instanceof BufferedImage) {
            return (BufferedImage) image;
        }

        // This code ensures that all the pixels in the image are loaded
        image = new ImageIcon(image).getImage();
        //icon = new ImageIcon(icon).getImage();

        // Create a buffered image with a format that's compatible with the screen
        BufferedImage bimage = null;
            // Determine if the image has transparent pixels; for this method's
            // implementation, see e661 Determining If an Image Has Transparent Pixels
            boolean hasAlpha;
            try {
                hasAlpha = hasAlpha(image);
            } catch (IllegalAccessError e) {
                // If we can't determine this, we assume that we have an alpha,
                // in order not to loose data.
                hasAlpha = true;
            }

            GraphicsEnvironment ge = GraphicsEnvironment.getLocalGraphicsEnvironment();
            try {
                // Determine the type of transparency of the new buffered image
                int transparency = Transparency.OPAQUE;
                if (hasAlpha) {
                    transparency = Transparency.TRANSLUCENT;
                }

                // Create the buffered image
                GraphicsDevice gs = ge.getDefaultScreenDevice();
                GraphicsConfiguration gc = gs.getDefaultConfiguration();
                bimage = gc.createCompatibleImage(
                        SIZE, SIZE, transparency);
            } catch (Exception e) {
                //} catch (HeadlessException e) {
                // The system does not have a screen
            }

            if (bimage == null) {
                // Create a buffered image using the default color model
                int type = BufferedImage.TYPE_INT_RGB;
                if (hasAlpha) {
                    type = BufferedImage.TYPE_INT_ARGB;
                }
                bimage = new BufferedImage(SIZE, SIZE, type);
            }

            // Copy image to buffered image
            Graphics2D g2d = bimage.createGraphics();
            UIDefaults uid = UIManager.getLookAndFeel().getDefaults();
            Color osColor = uid.getColor("Panel.background");
            g2d.setRenderingHint(RenderingHints.KEY_ANTIALIASING, RenderingHints.VALUE_ANTIALIAS_ON);
            //int loci = (SIZE-icon.getWidth(null))/2;
            int loc = (SIZE-image.getWidth(null))/2;

            // Paint the background image onto the buffered image
            //g2d.drawImage(icon, loci, loci, null);
            g2d.drawImage(image, loc, loc, null);

            // Paint the border onto the buffered image
            g2d.setColor(osColor.darker());
            RoundRectangle2D.Double rrect2D = new RoundRectangle2D.Double(0.0, 0.0, (double)SIZE-1.0, (double)SIZE-1.0, 6.0, 6.0);
            g2d.draw(rrect2D);
            g2d.setColor(osColor.brighter());
            rrect2D = new RoundRectangle2D.Double(1.0, 1.0, (double)SIZE-3.0, (double)SIZE-3.0, 6.0, 6.0);
            g2d.draw(rrect2D);

            // Paint the image icons onto the buffered image
            g2d.dispose();

            return bimage;
    }
    public static BufferedImage toBufferedImage(Image borderImage, Image bgImage, Image imageIcon) {
        if (borderImage instanceof BufferedImage) {
            return (BufferedImage) borderImage;
        }

        // This code ensures that all the pixels in the image are loaded
        borderImage = new ImageIcon(borderImage).getImage();
        bgImage = new ImageIcon(bgImage).getImage();
        imageIcon = new ImageIcon(imageIcon).getImage();

        // Create a buffered image with a format that's compatible with the screen
        BufferedImage bimage = null;

            // Determine if the image has transparent pixels; for this method's
            // implementation, see e661 Determining If an Image Has Transparent Pixels
            boolean hasAlpha;
            try {
                hasAlpha = hasAlpha(borderImage);
            } catch (IllegalAccessError e) {
                // If we can't determine this, we assume that we have an alpha,
                // in order not to loose data.
                hasAlpha = true;
            }

            GraphicsEnvironment ge = GraphicsEnvironment.getLocalGraphicsEnvironment();
            try {
                // Determine the type of transparency of the new buffered image
                int transparency = Transparency.OPAQUE;
                if (hasAlpha) {
                    transparency = Transparency.TRANSLUCENT;
                }

                // Create the buffered image
                GraphicsDevice gs = ge.getDefaultScreenDevice();
                GraphicsConfiguration gc = gs.getDefaultConfiguration();
                bimage = gc.createCompatibleImage(
                        borderImage.getWidth(null), borderImage.getHeight(null), transparency);
            } catch (Exception e) {
            }

            if (bimage == null) {
                // Create a buffered image using the default color model
                int type = BufferedImage.TYPE_INT_RGB;
                if (hasAlpha) {
                    type = BufferedImage.TYPE_INT_ARGB;
                }
                bimage = new BufferedImage(borderImage.getWidth(null), borderImage.getHeight(null), type);
            }

        // Copy image to buffered image
        Graphics2D g2d = bimage.createGraphics();
        UIDefaults uid = UIManager.getLookAndFeel().getDefaults();
        Color osColor = uid.getColor("Panel.background");
        g2d.setRenderingHint(RenderingHints.KEY_ANTIALIASING, RenderingHints.VALUE_ANTIALIAS_ON);
        g2d.setColor(Color.white);
        RoundRectangle2D.Double rect2D = new RoundRectangle2D.Double(0.0, 0.0, (double)borderImage.getWidth(null), (double)borderImage.getHeight(null), 8.0, 8.0);
        //g2d.draw3DRect(0, 0, borderImage.getWidth(null), borderImage.getHeight(null), true);
        g2d.fill(rect2D);
        g2d.setColor(osColor.darker());
        rect2D = new RoundRectangle2D.Double(1.0, 1.0, (double)borderImage.getWidth(null)-2.0, (double)borderImage.getHeight(null)-2.0, 8.0, 8.0);
        g2d.fill(rect2D);
        g2d.setColor(osColor);
        rect2D = new RoundRectangle2D.Double(2.0, 2.0, (double)borderImage.getWidth(null)-4.0, (double)borderImage.getHeight(null)-4.0, 8.0, 8.0);
        g2d.fill(rect2D);
        // Paint the images onto the buffered image
        //g.drawImage(borderImage, 0, 0, null);
        g2d.drawImage(bgImage, 4, 4, null);
        g2d.drawImage(imageIcon, 8, 8, null);
        g2d.dispose();

        return bimage;
    }
    /**
     * This method returns true if the specified image has transparent pixels
     *
     * Code taken from the Java Developers Almanac 1.4
     * http://javaalmanac.com/egs/java.awt.image/HasAlpha.html
     */
    public static boolean hasAlpha(Image image) {
        // If buffered image, the color model is readily available
        if (image instanceof BufferedImage) {
            BufferedImage bimage = (BufferedImage) image;
            return bimage.getColorModel().hasAlpha();
        }

        // Use a pixel grabber to retrieve the image's color model;
        // grabbing a single pixel is usually sufficient
        PixelGrabber pg = new PixelGrabber(image, 0, 0, 1, 1, false);
        try {
            pg.grabPixels();
        } catch (InterruptedException e) {
        }

        // Get the image's color model
        // We must check for null here, because the pixel grabber
        // may not have been able to retrieve the color model.
        ColorModel cm = pg.getColorModel();
        return (cm != null) ? cm.hasAlpha() : false;
    }
}
